#include "adlpuhu.c"
#include "joona.c"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#ifdef __BORLANDC__
#include <alloc.h>
#include <conio.h>
#include <dos.h>
#else
#define far /**/
#endif

#include "music.h"
#include "m_opl.h"
//#include "cons.h"

#undef delay

int nop = 110; // %

#if SUPPORT_MIDI
int ChorusLevel=30*127/100;
int ReverbLevel=40*127/100;
#endif

struct MusData MusData;
struct sbenv sbenv;
char SoundError[128];
int IsOPLThere;
int IsMPUThere=0;
int IsAWEThere=0;
int IsDSPThere=0;
int AWE_Found(void){return 0;}
int DSP_Found(void){return 0;}
int MPU_Found(void){return 0;}

int toupper(int a)
{
	if(a==''||a==''||a==''||a=='{')return '';
	if(a==''||a==''||        a=='|')return '';
	if(a>='a' && a<='z')return a-32;
	return a;
}

static InternalSample far *Instr[256];


void SubSano(char *s, int len)
{
	static const char Kovat[] = "BDGKPQT";
	static const char Kovat2[] = "BDGKPQTXZ";
//	static const char Kovat3[] = "BDGKPQTJ";
	static const char Voka[] = "AEIOUY";

	int F = 7000;

	for(; *s && !kbhit(); s++,len--)
	{
		int c=80;

		if(*s>='0' && *s<='9')
		{
			F = (*s-'0')*1000 - 1000;
			continue;
		}

		/* Savoa? *
		if(s[1]=='A' && s[2]=='A')s[1]='U';
		if(s[1]=='I'&&s[2])s[1]='J';
		if(*s=='D')*s='R';/**/

		printf("%c", *s);

		while(*s==s[1] && strchr(Kovat2, *s)!=NULL)
		{
			OPL_Touch(0,0,0);
			OPL_NoteOff(0);
			
			delay(140*nop/100);
			printf("%c", *s);
			s++, len--;
		}

		if(*s=='X')
		{
			memmove(s+1, s, len);
			s[0]='K';
			s[1]='S';
		}
		if(*s=='Z')
		{
			memmove(s+1, s, len);
			s[0]='T';
			s[1]='S';
		}

		if(*s=='K' && s[1]=='S')
		{
			OPL_Touch(0,0,0);
			OPL_NoteOff(0);
			delay(40*nop/100);
		}
		if(*s >= 'A')
		{
		//	printf("%c", *s);
			OPL_Patch(0, *s - 'A');
			OPL_Touch(0, *s - 'A', 63);
			OPL_NoteOn(0, (long)(MusData.Instr[*s-'A']->C2Spd)*F/8363);
		}
		else
		{
			OPL_Touch(0,0,0),OPL_NoteOff(0);//, printf(".");
			c=40;
		}
		if(strchr(Kovat, *s)!=NULL)
		{
			delay(40*nop/100);
			OPL_Touch(0,0,0),OPL_NoteOff(0);//, printf(".");
			c += (s[1] && s[1] <= ' ')?40:-40;
		}

		delay(c*nop/100);

		if(s[1] != *s || !strchr(Voka, *s))OPL_Touch(0,0,0),OPL_NoteOff(0);//, printf(".");

		if(!strchr(Voka, s[1]) && strchr(Voka, *s))
			F += F/30;
		else
			F -= F/30;
	}
}

int Stop(int c)
{
	return strchr(".,:;-\r\n?!", c) != NULL;
}

char *GetByte(char **p)
{
	static const char Voka[] = "AEIOUY";
	static const char Konso[] = "BCDFGHJKLMNPQRSTVWXZ";
	static const char Molemmat[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	static char Buf[32];
	int a, v;

	#define VOKA(n) (strchr(Voka, (n))!=NULL)
	#define KONSO(n) (strchr(Konso, (n))!=NULL)
	while(!strchr(Molemmat, **p))(*p)++;

	a = v = 0;

	if(KONSO(**p))Buf[a++] = *(*p)++;
	if(VOKA(**p))
		for(;;)
		{
			if(++v>2)break;
			Buf[a++] = *(*p)++;
			if(!**p)break;
			if(KONSO(**p))
			{
				v=0;
				if(VOKA(*(*p + 1)))break;
				Buf[a++] = *(*p)++;
				if(Stop(**p)||!KONSO(*(*p+1)))break;
			}
			else if(!VOKA(**p))break;
		}

	Buf[a] = 0;
	return Buf;
}

void Puhu(char *s)
{
	char Buf[1024];
	char *t, *p;
	char Buf2[64];
	int a;

	for(a=0; *s; s++)
		if(*s!='"')Buf[a++]=toupper(*s);
	Buf[a] = 0;

	for(p=Buf;;)
	{
		int c;
		t = GetByte(&p);
		if(!t || !*t)break;
		c = *p-' '?Stop(*p)?' ':'-':' ';
		Buf2[1] = 0;
		Buf2[0] = (c==' ' && *p!=' ')? '6' : '7';
		strcat(Buf2, t);
		SubSano(Buf2, 31);
		if(c==' ' && *p!=' '){printf(" -");delay(140*nop/100);}
		if(c==' ')putch(' ');//*/printf("%c", c);
	}

//	SubSano(Buf, sizeof Buf);
	printf("\n");
}

int main(void)
{
	int a;
	
//	InitCons();
	
	SelectMusDev(SelectOPL);

	char far *s = ADLPuhu;
	if(s[1]>2)for(;*s++;); // Skip possible song name
	InternalHdr far *h = (InternalHdr far *)s;
	s += sizeof *h;
	s += (byte)h->OrdNum;

	for(a=0; a<h->InsNum; a++)
	{
		InternalSample far *smp = (InternalSample far *)s;
		Instr[smp->GM-'A'] = smp;
		s += sizeof(InternalSample);
	}

//	Puhu("SUKUPOLVI                   CCCC\0\0");
#if 1
	char far *Ilmi = ilm;
	#define fgets(s, len, blah) \
		{char *t = s; int l = len; \
		while(l){l--, *t++=*Ilmi;if(*Ilmi++=='\n')break;} \
		*t=0;}
#else
	FILE *fp = fopen("e:\\bibleftp\\fin\\03_jh", "rt");
//	FILE *fp = fopen("e:\\bibleftp\\fin\\1ms", "rt");
	if(!fp)
	{
	/*	Sano("7o 6j5eessh                    ");

		Sano("5Nyt  6testataan 6tt5  7ett  6toimiiko  6t5m          ");
		Sano("epjrjestelmllistyttmttmyydellnskn              ");
		Sano("leffalipunmyyntipllikksulkahattukauppaketjukolarivakuutuskauppias            ");
		Sano("7HELLU        7AI 4M 8OKTOUB     8ND  5AI  4TRAI  TU  4SPIIK    4 7BIT      5OFF     6INNGLISS|");
	*/
	}
	else
#endif
	{
		char Line[1024];
		char Buf[1024];
		do{fgets(Buf, 1023, fp);}while(Buf[0]=='\n');
		Puhu(Buf);
		do{fgets(Buf, 1023, fp);}while(Buf[0]=='\n');

		for(Line[0]=0; !kbhit(); )
		{
			int i;
			for(i=strlen(Buf);i;Buf[i]=0)if(!strchr("\r\n\t ",Buf[--i]))break;

			if(Buf[0] == '\t' && !strcmp(Buf+i-3, "Luku"))
			{
				int a = atoi(Buf);

				Line[0] = 0;
				switch((a/100)%10)
				{
					case 1: strcpy(Line, "sadas "); break;
				}
				switch((a/10)%10)
				{
					case 2: strcat(Line, "kahde"); break;
					case 3: strcat(Line, "kolma"); break;
					case 4: strcat(Line, "nelj"); break;
					case 5: strcat(Line, "viide"); break;
					case 6: strcat(Line, "kuude"); break;
					case 7: strcat(Line, "seitsem"); break;
					case 8: strcat(Line, "kahdeksa"); break;
					case 9: strcat(Line, "yhdeks"); break;
				}
				if((a%100)>19)strcat(Line, "s kymmenes ");
				switch(a%10)
				{
					case 1: strcat(Line, ((a/10)%10)==1?"yhdes":"ensimminen"); break;
					case 2: strcat(Line, "toinen"); break;
					case 3: strcat(Line, "kolmas"); break;
					case 4: strcat(Line, "neljs"); break;
					case 5: strcat(Line, "viides"); break;
					case 6: strcat(Line, "kuudes"); break;
					case 7: strcat(Line, "seitsems"); break;
					case 8: strcat(Line, "kahdeksas"); break;
					case 9: strcat(Line, "yhdekss"); break;
				}
				if((a%100)==10)strcat(Line, "kymmenes ");
				if((a%100)>10 && (a%100)<20)strcat(Line, "toista");

				strcat(Line, " luku.");
			}
			else if(Buf[0]>='0' && Buf[0]<='9')
			{
				Puhu(Line);
				strcpy(Line, strchr(Buf, ' ')+1);
			}
			else
			{
				strcat(Line, " ");
				strcat(Line, Buf);
			}
			#ifdef fgets
			fgets(Buf, 1023, fp);
			#else
			if(!fgets(Buf, 1023, fp))break;
			#endif
		}
		Puhu(Line);
		#ifndef fgets
		fclose(fp);
		#endif
	}
	while(kbhit())getch();

//	DoneCons();

	return 0;
}
